'use strict';const PropTypes=require('prop-types'),React=require('react'),shapeup=require('shapeup'),BasicTable=require('../../basic-table/basic-table'),CredentialAddEdit=require('../../credential-add-edit/credential-add-edit'),ExpandingRow=require('../../expanding-row/expanding-row'),GenericButton=require('../../generic-button/generic-button'),MoreMenu=require('../../more-menu/more-menu'),ProfileCredentialListDelete=require('./delete/delete'),Spinner=require('../../spinner/spinner'),LOCAL_CLOUD='localhost';class ProfileCredentialList extends React.Component{constructor(a){super(a),this.state={credentialMap:new Map,editCredential:null,loading:!1,removeCredential:null,showAdd:!1}}componentDidMount(){this._getClouds()}async _getClouds(){const a=this.props;this.setState({loading:!0,editCredential:null});try{const b=await this._listClouds(),c=await this._getCloudCredentialNames(a.username,b),d=await this._fetchAndFilterModelsByCredential();d.forEach((a,b)=>{c.has(b)&&(b=c.get(b).models=a)}),this.setState({credentialMap:c,loading:!1})}catch(b){this.setState({loading:!1});const c='Unable to fetch credential data';a.addNotification({title:c,message:c,level:'error'}),console.error(c,b)}}_listClouds(){return new Promise((a,b)=>{this.props.controllerAPI.listClouds((c,d)=>{return c?void b(c):void a(Object.keys(d))})})}_getCloudCredentialNames(a,b){return new Promise((c,d)=>{this.props.controllerAPI.getCloudCredentialNames(b.map((b)=>[a,b]),(a,b)=>{if(a)return void d(a);const e=new Map;Object.values(b).forEach((a)=>{a.names.forEach((b,c)=>{e.set(b,{cloud:b.split('_')[0],displayName:a.displayNames[c]})})}),c(e)})})}_fetchAndFilterModelsByCredential(){const a=this.props;return new Promise((b,c)=>{a.controllerAPI.listModelsWithInfo((d,e)=>{if(d)return void c(d);const f=new Map;e.filter((b)=>b.owner===a.username).forEach((a)=>{const b=a.credential,c=a.name;f.has(b)?f.get(b).push(c):f.set(b,[c])}),b(f)})})}_toggleAdd(){this.setState({showAdd:!this.state.showAdd})}_setEditCredential(a=null){this.setState({editCredential:a})}_setDeleteCredential(a=null){this.setState({removeCredential:a})}_generateAddCredentials(){const a=this.state.showAdd?this._generateCredentialForm():null;return React.createElement(ExpandingRow,{classes:{"twelve-col":!0},clickable:!1,expanded:this.state.showAdd},React.createElement('div',null),React.createElement('div',{className:'twelve-col'},a))}_generateEditCredentials(a,b){return b===this.state.editCredential?this._generateCredentialForm({credential:a,onCancel:this._setEditCredential.bind(this),onCredentialUpdated:this._onCredentialEdited.bind(this)}):null}_onCredentialEdited(){this._getClouds(),this._setEditCredential()}_onCredentialAdded(){this._getClouds(),this._toggleAdd()}_onCredentialDeleted(){this._getClouds(),this._setDeleteCredential()}_generateCredentialForm(a={}){const b=this.props.controllerAPI,c=this.state.credentialMap;return React.createElement(CredentialAddEdit,{key:'deployment-credential-add',acl:this.props.acl,addNotification:this.props.addNotification,controllerAPI:shapeup.addReshape({listClouds:b.listClouds.bind(b),updateCloudCredential:b.updateCloudCredential.bind(b)}),controllerIsReady:this.props.controllerIsReady,credential:a.credential,credentials:c?Array.from(c).map((a)=>a[0]):[],initUtils:this.props.initUtils,onCancel:a.onCancel||this._toggleAdd.bind(this),onCredentialUpdated:a.onCredentialUpdated||this._onCredentialAdded.bind(this),sendAnalytics:this.props.sendAnalytics,username:this.props.username})}_generateDeleteCredential(){const a=this.state.removeCredential;return a?React.createElement(ProfileCredentialListDelete,{addNotification:this.props.addNotification,credential:a,onCancel:this._setDeleteCredential.bind(this),onCredentialDeleted:this._onCredentialDeleted.bind(this),revokeCloudCredential:this.props.controllerAPI.revokeCloudCredential}):null}_generateCredentialsList(){const a=this.state,b=a.credentialMap;if(a.loading)return React.createElement(Spinner,null);if(0===b.size)return React.createElement('div',null,'No credentials available');let c=[];const d=this.props.credential;return b.forEach((a,b)=>{c.push({classes:b===d?['profile-credential-list--highlighted']:null,columns:[{content:a.displayName,columnSize:6},{content:a.cloud,columnSize:2},{content:function(){const b=a.models,c=b?b.length:0;switch(c){case 0:return'-';break;case 1:return`${a.models[0]}`;break;default:return`${c} Models`;}}(),columnSize:3},{content:React.createElement(MoreMenu,{icon:'contextual-menu-horizontal',items:[{label:'Edit',action:this._setEditCredential.bind(this,b)},{label:'Delete',action:this._setDeleteCredential.bind(this,b)}]}),columnSize:1}],expandedContent:this._generateEditCredentials(a,b),expandedContentExpanded:this.state.editCredential===b,key:b,rowClickable:!1})}),React.createElement(BasicTable,{headerClasses:['profile__entity-table-header-row'],headerColumnClasses:['profile__entity-table-header-column'],headers:[{content:'Name',columnSize:6},{content:'Provider',columnSize:2},{content:'Used by',columnSize:3},{content:'Action',columnSize:1}],rowClasses:['profile__entity-table-row'],rowColumnClasses:['profile__entity-table-column'],rows:c})}render(){const a=this.state.clouds;let b=React.createElement(GenericButton,{action:this._toggleAdd.bind(this),type:'inline-neutral'},'Add credentials');return a&&a[LOCAL_CLOUD]&&(b=null),React.createElement('div',{className:'profile-credential-list'},React.createElement('div',{className:'four-col'},React.createElement('h2',{className:'profile__title'},'My credentials',React.createElement('span',{className:'profile__title-count'},'(',this.state.credentialMap.size,')'))),React.createElement('div',{className:'push-four four-col'},React.createElement('div',{className:'profile-credential-list__add'},b)),this._generateAddCredentials(),this._generateCredentialsList(),this._generateDeleteCredential())}}ProfileCredentialList.propTypes={acl:shapeup.shape({isReadOnly:PropTypes.func.isRequired}).isRequired,addNotification:PropTypes.func.isRequired,controllerAPI:shapeup.shape({getCloudCredentialNames:PropTypes.func.isRequired,listClouds:PropTypes.func.isRequired,listModelsWithInfo:PropTypes.func.isRequired,revokeCloudCredential:PropTypes.func.isRequired,updateCloudCredential:PropTypes.func.isRequired}),controllerIsReady:PropTypes.func.isRequired,credential:PropTypes.string,initUtils:shapeup.shape({generateCloudCredentialName:PropTypes.func.isRequired,getCloudProviderDetails:PropTypes.func.isRequired,reshape:shapeup.reshapeFunc,validateForm:PropTypes.func.isRequired}).isRequired,sendAnalytics:PropTypes.func.isRequired,username:PropTypes.string.isRequired},module.exports=ProfileCredentialList;