'use strict';const ReactDOM=require('react-dom'),mixwith=require('mixwith'),acl=require('./store/env/acl'),analytics=require('./init/analytics'),utils=require('./init/utils'),jujulibConversionUtils=require('./init/jujulib-conversion-utils'),viewUtils=require('./views/utils'),hotkeys=require('./init/hotkeys'),csUser=require('./init/charmstore-user'),cookieUtil=require('./init/cookie-util'),BundleImporter=require('./init/bundle-importer'),EndpointsController=require('./init/endpoints-controller'),WebHandler=require('./store/env/web-handler'),newBakery=require('./init/utils/bakery-utils'),EnvironmentView=require('./init/topology/environment'),ComponentRenderersMixin=require('./init/component-renderers-mixin'),DeployerMixin=require('./init/deployer-mixin');window.juju.utils.RelationUtils=require('./init/relation-utils');const yui=window.yui;window.models=yui.namespace('juju.models');class GUIApp{constructor(a){this.applicationConfig=this._processApplicationConfig(a),this.modelUUID=a.jujuEnvUUID||null,this.defaultPageTitle='Juju GUI',this._userPaths=new Map,this.anonymousMode=!1,this._domEventHandlers={},this._dragLeaveTimer=null,this._hotkeyListener=hotkeys.activate(this),this.db=new yui.juju.models.Database({getECS:()=>this.ecs}),this._dbChangedTimer=null,this._domEventHandlers.boundOnDatabaseChanged=this.onDatabaseChanged.bind(this),document.addEventListener('update',this._domEventHandlers.boundOnDatabaseChanged),this.user=a.user||new window.jujugui.User({externalAuth:a.auth,expiration:window.sessionStorage.getItem('expirationDatetime')}),this.users=csUser.create();const b=new WebHandler;this.bakery=newBakery(a,this.user,()=>this.state.current,(a,b)=>{this.charmstore.setAuthCookie(a,b)},b),this.identity=this._setupIdentity(this.user,window.jujulib.identity),this.charmstore=this._setupCharmstore(a,window.jujulib.charmstore),this.bundleService=this._setupBundleservice(a,window.jujulib.bundleservice),this.ecs=this._setupEnvironmentChangeSet();const c={user:this.user,ecs:this.ecs,conn:a.conn,jujuCoreVersion:a.jujuCoreVersion,bundleService:this.bundleService},d=Object.assign({},c),e=yui.juju.environments;c.webHandler=new WebHandler,this.modelAPI=new e.GoEnvironment(c),this.modelAPI.after('environmentNameChange',this.onModelNameChange,this),this.modelAPI.after('defaultSeriesChange',this.onDefaultSeriesChange,this),this.modelAPI.after('connectedChange',(a)=>{if(this._renderProviderLogo(),!a.newVal)return void console.log('model disconnected');console.log('model connected'),this.modelAPI.userIsAuthenticated=!1;const b=this.user.model;if(b.areAvailable)return void this.loginToAPIs(null,!!b.macaroons,[this.modelAPI])}),this.modelController=new yui.juju.ModelController({db:this.db,env:this.modelAPI,charmstore:this.charmstore}),this.endpointsController=new EndpointsController({db:this.db,modelController:this.modelController}),this.endpointsController.bind(),this.controllerAPI=new yui.juju.ControllerAPI(d),this.sendAnalytics=analytics.sendAnalyticsFactory(this.controllerAPI,window.dataLayer);let f=a.baseUrl;0>f.indexOf('://')&&(f=`${window.location.origin}${f}`),this.state=this._setupState(f),this._setupControllerAPI(),this._setupRomulusServices(a,window.jujulib),this.stats=null,a.statsURL&&(this.stats=new window.jujugui.StatsClient(a.statsURL,'gui')),this.bundleImporter=new BundleImporter({db:this.db,modelAPI:this.modelAPI,getBundleChanges:this.controllerAPI.getBundleChanges.bind(this.controllerAPI),makeEntityModel:jujulibConversionUtils.makeEntityModel,charmstore:this.charmstore,hideDragOverNotification:this._hideDragOverNotification.bind(this)}),a.gisf&&document.body.classList.add('u-is-beta'),this.acl=new acl.generateAcl(this.controllerAPI,this.modelAPI),window.onbeforeunload=utils.unloadWindow.bind(this),this._handleMaasServer(),this._domEventHandlers.onDeltaBound=this.db.onDelta.bind(this.db),document.addEventListener('delta',this._domEventHandlers.onDeltaBound),this.db.machines.after(['add','remove','*:change'],this.onDatabaseChanged,this),this.db.services.after(['add','remove','*:change'],this.onDatabaseChanged,this),this.db.relations.after(['add','remove','*:change'],this.onDatabaseChanged,this),this.db.environment.after(['add','remove','*:change'],this.onDatabaseChanged,this),this.db.environment.after(['add','remove','*:change'],this._renderModelActions,this),this.db.units.after(['add','remove','*:change'],this.onDatabaseChanged,this),this.db.notifications.after('add',this._renderNotifications,this),this._domEventHandlers.onInitiateDeploy=(a)=>{this.deployService(a.detail.charm,a.detail.ghostAttributes)},document.addEventListener('initiateDeploy',this._domEventHandlers.onInitiateDeploy),this._domEventHandlers.boundAppDragOverHandler=this._appDragOverHandler.bind(this),['dragenter','dragover','dragleave'].forEach((a)=>{document.addEventListener(a,this._domEventHandlers.boundAppDragOverHandler)}),this._bindRenderUtilities(),this.topology=this._renderTopology(),this._renderComponents(),this._renderUserMenu();const g=this.state.bootstrap();g.error&&console.error(g.error)}_processApplicationConfig(a){return a.flags||(a.flags={}),a}_bindRenderUtilities(){this._bound={addNotification:this.db.notifications.add.bind(this.db.notifications),changeState:this.state.changeState.bind(this.state),destroyModels:this.controllerAPI.destroyModels.bind(this.controllerAPI),listModelsWithInfo:this.controllerAPI.listModelsWithInfo.bind(this.controllerAPI)},this._bound.switchModel=utils.switchModel.bind(this,this.modelAPI,this._bound.addNotification)}_setupIdentity(a,b){return void 0===this.identity&&(this.identity=new b(a,this.bakery)),this.identity}_setupCharmstore(a,b){return void 0===this.charmstore&&(this.charmstore=new b(a.charmstoreURL,this.bakery),this.bakery.storage.get(a.charmstoreURL)&&(this.users.charmstore={loading:!0},this.storeUser('charmstore',!1,!0))),this.charmstore}_setupBundleservice(a,b){if(this.bundleService===void 0){const c=a&&a.bundleServiceURL;if(!a||!c){console.error('no juju config for bundleserviceURL available');const a='The service for handling bundles is not available. Please try refreshing the GUI.';return void this.db.notifications.add({title:a,message:a,level:'error'})}return new b(c,new WebHandler())}return this.bundleService}_setupEnvironmentChangeSet(){if(void 0===this.ecs){this._domEventHandlers.renderDeploymentBarListener=this._renderDeploymentBar.bind(this);const a=this._domEventHandlers.renderDeploymentBarListener;return document.addEventListener('ecs.changeSetModified',a),document.addEventListener('ecs.currentCommitFinished',a),new yui.juju.EnvironmentChangeSet({db:this.db})}return this.ecs}_ensureControllerConnection(a,b){this.controllerAPI.get('connecting')||this.controllerAPI.get('connected')||this.controllerAPI.connect(),b()}authorizeCookieUse(a,b){this.applicationConfig.GTM_enabled&&cookieUtil.check(document),b()}checkUserCredentials(a,b){if(a&&('new'===a.root||'new'===a.root&&''===a.store))return void b();const c=[this.modelAPI,this.controllerAPI],d=c.some((a)=>{return a&&a.get('connected')&&!a.get('connecting')&&!a.userIsAuthenticated&&!this.applicationConfig.gisf});return d?void this._displayLogin():void b()}_setupState(a){if(this.state)return this.state;const b=new window.jujugui.State({baseURL:a,seriesList:window.jujulib.SERIES,sendAnalytics:this.sendAnalytics});return b.register([['*',this._ensureControllerConnection.bind(this)],['*',this.authorizeCookieUse.bind(this)],['*',this.checkUserCredentials.bind(this)],['*',this._renderComponents.bind(this)],['root',this._rootDispatcher.bind(this),this._clearRoot.bind(this)],['profile',this._renderUserProfile.bind(this),this._clearUserProfile.bind(this)],['user',this._handleUserEntity.bind(this),this._clearUserEntity.bind(this)],['model',this._handleModelState.bind(this)],['store',this._renderCharmbrowser.bind(this),this._clearCharmbrowser.bind(this)],['search',this._renderCharmbrowser.bind(this),this._clearCharmbrowser.bind(this)],['help',this._renderHelp.bind(this),this._clearHelp.bind(this)],['special.deployTarget',this._deployTarget.bind(this)],['gui',null,this._clearAllGUIComponents.bind(this)],['gui.machines',this._renderMachineView.bind(this),this._clearMachineView.bind(this)],['gui.status',this._renderStatusView.bind(this),this._clearStatusView.bind(this)],['gui.inspector',this._renderInspector.bind(this)],['gui.deploy',this._renderDeployment.bind(this),this._clearDeployment.bind(this)],['postDeploymentPanel',this._displayPostDeployment.bind(this),this._clearPostDeployment.bind(this)],['terminal',this._displayTerminal.bind(this),this._clearTerminal.bind(this)],['hash'],['special.dd']]),b}_rootDispatcher(a,b){switch(a.root){case'login':this._renderLogin(),b();break;case'logout':return this._handleLogout(),void this.state.changeState({root:'login'});break;case'new':this.modelAPI.get('connected')&&this._switchModelToUUID();const c=this.controllerAPI.userIsAuthenticated;(this.anonymousMode||c)&&this.maskVisibility(!1);const d=a.special;d&&d.dd&&this._directDeploy(d.dd);break;default:b();}}_handleModelState(a,b){const c=this.modelAPI;this.modelUUID===a.model.uuid&&(c.get('connected')||c.get('connecting'))||this._switchModelToUUID(a.model.uuid),b()}_switchModelToUUID(a){let b;if(a){console.log('switching to model: ',a),this.modelUUID=a;const c=this.applicationConfig;b=utils.createSocketURL({protocol:c.socket_protocol,apiAddress:c.apiAddress,template:c.socketTemplate,uuid:a})}else console.log('switching to disconnected mode'),this.modelUUID=null;this.switchEnv(b)}_clearRoot(a,b){this._clearLogin(a,b),b()}_handleUserEntity(a){this._disambiguateUserState(this._fetchEntityFromUserState(a.user))}_clearUserEntity(a,b){const c=document.getElementById('charmbrowser-container');0<c.childNodes.length&&ReactDOM.unmountComponentAtNode(c),b()}_setupRomulusServices(a){a&&((this.plans||this.terms)&&console.error('romulus services are being redefined:',this.plans,this.terms),this.plans=new window.jujulib.plans(a.plansURL,this.bakery),this.terms=new window.jujulib.terms(a.termsURL,this.bakery),a.flags.pay&&(this.payment=new window.jujulib.payment(a.paymentURL,this.bakery),this.stripe=new window.jujulib.stripe('https://js.stripe.com/',a.stripeKey)))}_handleMaasServer(){let a=this.modelAPI.get('maasServer');!a&&this.controllerAPI&&(a=this.controllerAPI.get('maasServer')),a?this._displayMaasLink(a):(this.controllerAPI&&this.controllerAPI.once('maasServerChange',this._onMaasServer,this),this.modelAPI.once('maasServerChange',this._onMaasServer,this))}_fetchEntityFromUserState(a){const b=this._userPaths,c=b.get(a);if(c&&c.promise)return c.promise;const d=new Promise((b,c)=>{let d;try{d=window.jujulib.URL.fromString('u/'+a).legacyPath()}catch(b){return void c(a)}this.charmstore.getEntity(d,(d)=>{return d?(console.log('model/charm store disambiguation:',d),void c(a)):void b(a)})});return b.set(a,{promise:d}),d}_setupControllerAPI(){const a=this.state.generateState(window.location.href,!1);let b=null;!a.error&&a.state.user&&(b=this._fetchEntityFromUserState(a.state.user)),this._domEventHandlers.controllerLoginHandler=this._controllerLoginHandler.bind(this,b),document.addEventListener('login',this._domEventHandlers.controllerLoginHandler),this.controllerAPI.after('connectedChange',this._controllerConnectedChangeHandler.bind(this));const c=this.applicationConfig;this.controllerAPI.set('socket_url',utils.createSocketURL({apiAddress:c.apiAddress,template:c.controllerSocketTemplate,protocol:c.socket_protocol}))}_controllerLoginHandler(a,b){const c=this.state;if(this.anonymousMode=!1,b.detail&&b.detail.err)return void this._renderLogin(b.detail.err);this._renderUserMenu(),console.log('successfully logged into controller'),this.applicationConfig.gisf?(this._sendGISFPostBack(()=>{this.reloadConfigFile(document)}),this._ensureLoggedIntoCharmstore()):this.reloadConfigFile(document);const d=c.current.special,e=d&&d.next,f=d&&d.dd;if('login'===c.current.root){if(c.changeState({root:null}),f)return console.log('initiating direct deploy'),this.maskVisibility(!1),void this._directDeploy(f);if(e){console.log('redirecting to "next" state',e);const{error:a,state:b}=c.generateState(e,!1);return null===a?(b.special=null,this.maskVisibility(!1),void c.changeState(b)):void console.error('error redirecting to previous state',a)}}if(!this.modelAPI.get('modelUUID')){const b=c.current,d=this.modelUUID;if(d&&!b.profile&&''!==b.store)this._listAndSwitchModel(null,d);else if(null!==a)this._disambiguateUserState(a);else{this.maskVisibility(!1);const a='login'===b.root,d=c.previous,e=d&&d.root||null;let f={profile:e&&'login'!==e?null:b.profile,root:a?e:b.root};b.store||f.profile||'account'===f.root||!a&&b.root||!this.applicationConfig.gisf||(f.profile=this.user.displayName),c.changeState(f)}}}_controllerConnectedChangeHandler(a){if(!a.newVal)return void console.log('controller disconnected');console.log('controller connected');const b=this.user.controller,c=this.applicationConfig.gisf,d=this.state.current,e=d?d.root:null;return!b.areAvailable&&c&&'new'===e||this.anonymousMode&&'login'!==e?(this.anonymousMode=!0,console.log('now in anonymous mode'),void this.maskVisibility(!1)):!b.areAvailable||d.special&&d.special.dd?void this._displayLogin():b.macaroons||b.areExternal?void this.loginToAPIs(null,!0,[this.controllerAPI]):void this.loginToAPIs(null,c,[this.controllerAPI])}onModelNameChange(a){const b=a.newVal||'untitled-model';this.db.environment.set('name',b),this._renderBreadcrumb(),this.defaultPageTitle=`${b} - Juju GUI`,this.setPageTitle()}onDefaultSeriesChange(a){this.db.environment.set('defaultSeries',a.newVal)}onDatabaseChanged(){const a=this._dbChangedTimer;return a&&clearTimeout(a),void(this._dbChangedTimer=setTimeout(this._dbChangedHandler.bind(this),100))}_dbChangedHandler(){this.topology.topo.update(),this.state.dispatch(),this._renderComponents()}_appDragOverHandler(a){a.preventDefault();const b=this._determineFileType(a.dataTransfer);!1===b||('dragenter'===a.type&&this._renderDragOverNotification(),this._dragleaveTimerControl('dragover'===a.type?'stop':'start'))}_dragleaveTimerControl(a){this._dragLeaveTimer&&(window.clearTimeout(this._dragLeaveTimer),this._dragLeaveTimer=null),'start'===a&&(this._dragLeaveTimer=setTimeout(()=>{this._hideDragOverNotification()},100))}_determineFileType(a){const b=a.types;if(!Object.keys(b).some((a)=>'Files'===b[a]))return!1;if(a.items){const b=a.items[0];return'application/zip'===b.type||'application/x-zip-compressed'===b.type?'zip':'yaml'}return''}setPageTitle(a){document.title=a?`${a} - Juju GUI`:this.defaultPageTitle}_displayLogin(){const a=this.state.current.root;'login'!==a&&this.state.changeState({root:'login'})}loginToAPIs(a,b,c=[this.controllerAPI,this.modelAPI]){return b?void c.forEach((a)=>{a&&a.get('connected')&&(console.log(`logging into ${a.name} with macaroons`),a.loginWithMacaroon(this.bakery,this._apiLoginHandler.bind(this,a)))}):void c.forEach((b)=>{b&&(a&&'model-api'===b.name?this.user.model=a:a&&(this.user.controller=a),b.get('connected')&&(console.log(`logging into ${b.name} with user and password`),b.login()))})}_apiLoginHandler(a,b){return b?viewUtils.isRedirectError(b)?void(console.log(`redirection required for loggin into ${a.name}`),a.redirectInfo((a,b)=>{if(a)return void this.db.notifications.add({title:'Unable to log into Juju',message:a,level:'error'});const c=b[0],d=c.filter((a)=>'public'===a.scope);if(!d.length)return this.db.notifications.add({title:'Model connection error',message:'Cannot find a public host for connecting to the model',level:'error'}),void console.error('no public hosts found: '+JSON.stringify(b));const e=d[0],f=this.applicationConfig;this.switchEnv(utils.createSocketURL({apiAddress:f.apiAddress,template:f.socketTemplate,protocol:f.socket_protocol,uuid:this.modelUUID,server:e.value,port:e.port}),null,null,null,!0,!1)})):void console.log(`cannot log into ${a.name}: ${b}`):void 0}switchEnv(a,b,c,d,e=!!a,f=!0){console.log('switching model connection'),this.modelAPI.loading=!0,b&&c&&(this.user.model={user:b,password:c});const g=this.user.model;document.addEventListener('model.login',((a)=>{this.modelAPI.loading=!1,a&&a(this.modelAPI);const b=this.state.current;'login'===b.root&&this.state.changeState({root:null})}).bind(this,d),{once:!0}),f&&this.modelAPI.get('ecs').clear();const h=(b)=>{b.set('socket_url',a),this.user.model=g,e&&b.connect()},i=function(){this.on_close(),h(this)}.bind(this.modelAPI);this.modelAPI.ws?(this.modelAPI.ws.onclose=i,this.modelAPI.close(),!this.modelAPI.get('connected')&&h(this.modelAPI)):this.modelAPI.close(i),f&&(this.db.reset(),this.db.fireEvent('update')),this.topology&&(this.topology.topo.modules.ServiceModule.centerOnLoad=!0),'new'===this.state.current.root&&(this.modelAPI.loading=!1)}_listAndSwitchModel(a,b){this.controllerAPI.listModelsWithInfo((c,d)=>{if(c)return console.error('unable to list models',c),void this.db.notifications.add({title:'Unable to list models',message:'Unable to list models: '+c,level:'error'});const e=d.filter((a)=>!a.err),f=(a,b)=>`${a.split('@')[0]}/${b}`;let g;if(a?g=e.find((b)=>f(b.owner,b.name)===a):b&&(g=e.find((a)=>a.uuid===b)),this.maskVisibility(!1),!(g&&this.modelAPI.get('modelUUID')===g.uuid))if(g)this.state.changeState({model:{path:f(g.owner,g.name),uuid:g.uuid},user:null,root:null});else{const b=`no such charm, bundle or model: u/${a}`;console.log(b),this.state.changeState({root:null,store:null,model:null,user:null,profile:this.user.displayName})}})}_disambiguateUserState(a){a.then((a)=>{console.log('entity found, showing store'),this.maskVisibility(!1),this.state.changeState({store:'u/'+a,user:null})}).catch((a)=>{return this.controllerAPI.userIsAuthenticated?void this._listAndSwitchModel(a):void console.log('not logged into controller')})}_sendGISFPostBack(a){const b=this.user.getMacaroon('identity');if(!b){console.error('no discharge token in local storage after login');const a='Authentication failed. Please try refreshing the GUI.';return void this.db.notifications.add({title:a,message:a,level:'error'})}console.log('sending discharge token to storefront');const c=new WebHandler;c.sendPostRequest('/_login',{"Content-Type":'application/x-www-form-urlencoded'},'discharge-token='+b,null,null,null,null,a)}_getUserInfo(a){const b=a.profile||this.user.displayName||'',c={external:b,isCurrent:!1,profile:b};if(c.profile===this.user.displayName){c.isCurrent=!0;const a=this.users||{};c.external=a.charmstore?a.charmstore.user:null}return c}_getModelName(){return this.modelAPI.get('environmentName')}_ensureLoggedIntoCharmstore(){this.user.getMacaroon('charmstore')||this.charmstore.getMacaroon((a)=>{if(a){const b='Authentication failed. Please try refreshing the GUI.';return console.error(b,a),void this.db.notifications.add({title:b,message:`${b}: ${a}`,level:'error'})}this.storeUser('charmstore',!0),console.log('logged into charmstore')})}_onMaasServer(a){a.newVal===a.prevVal||this._displayMaasLink(a.newVal)}_displayMaasLink(a){if(null!==a){const b=document.querySelector('#maas-server');b.querySelector('a').setAttribute('href',a),b.classList.remove('hidden')}}maskVisibility(a=!0){var b=document.getElementById('full-screen-mask'),c=a?'block':'none';b&&(b.style.display=c)}_directDeploy(a){const b=this.state.current;b&&b.gui&&b.gui.deploy||(this.addToModel(this.charmstore,a.id),this.state.changeState({gui:{deploy:JSON.stringify(a)},postDeploymentPanel:{entityId:a.id}}))}_deployTarget(a,b){this.state.changeState({special:{deployTarget:null}}),this.addToModel(this.charmstore,a.special.deployTarget),b()}addToModel(a,b){const c=(a)=>{let c=`Unable to deploy target: ${b}`;try{c=JSON.parse(a.currentTarget.responseText).Message}catch(a){console.error(a)}this.db.notifications.add({title:'Error deploying target.',message:c,level:'error'})},d=window.jujulib.URL.fromLegacyString(b);d.isBundle()?a.getBundleYAML(b,(a,b)=>{a?c(a):this.bundleImporter.importBundleYAML(b,d.path())}):a.getEntity(d.legacyPath(),(a,b)=>{if(a)c(a);else{b=b[0];let a={},c=b.get?b.get('options'):b.options;Object.keys(c).forEach(function(b){a[b]=c[b]['default']}),this.deployService(new yui.juju.models.Charm(b))}})}_renderTopology(){const a=new EnvironmentView({endpointsController:this.endpointsController,db:this.db,env:this.modelAPI,ecs:this.ecs,charmstore:this.charmstore,bundleImporter:this.bundleImporter,state:this.state,staticURL:this.applicationConfig.staticURL,sendAnalytics:this.sendAnalytics,container:document.querySelector(this.applicationConfig.container||'#main')});return a.render(),a.topo.modules.ViewportModule.resized(),a}_handleLogout(){const a=this.applicationConfig;this.clearUser(),this.bakery.storage.clear();const b=this.topology;b&&b.topo.update(),this.modelUUID='',this.loggedIn=!1;const c=this.controllerAPI,d=c.close.bind(c);if(this.modelAPI.close(()=>{d(()=>{c.connect(),this.maskVisibility(!0),this.modelAPI.get('ecs').clear(),this.db.reset(),this.db.fireEvent('update'),this.state.changeState({model:null,profile:null,root:null,store:null})})}),a.gisf){const b=a.gisfLogout||'';window.location.assign(window.location.origin+b)}}reloadConfigFile(a){const b=a.querySelector('script[data=config]'),c=a.createElement('script');c.setAttribute('data','config'),c.src=b.src,c.onload=()=>{this.applicationConfig=this._processApplicationConfig(juju_config),this.state.dispatch()},b.parentNode.removeChild(b),a.getElementsByTagName('head')[0].appendChild(c)}destructor(){this._dbChangedTimer&&clearTimeout(this._dbChangedTimer),this.modelAPI&&this.modelAPI.destroy(),this.controllerAPI.destroy(),this.db.destroy(),this.endpointsController.destructor(),this.topology.destructor(),this._hotkeyListener.deactivate();const a=document.removeEventListener.bind(document),b=this._domEventHandlers,c=b.renderDeploymentBarListener;a('ecs.changeSetModified',c),a('ecs.currentCommitFinished',c),a('login',b.controllerLoginHandler),a('delta',b.onDeltaBound),a('update',b.boundOnDatabaseChanged),a('initiateDeploy',b.onInitiateDeploy),['dragenter','dragover','dragleave'].forEach((c)=>{a(c,b.boundAppDragOverHandler)})}}class JujuGUI extends mixwith.mix(GUIApp).with(csUser.CharmstoreUserMixin,ComponentRenderersMixin,DeployerMixin){}module.exports=JujuGUI;