'use strict';chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('jujulib payment service',function(){let a,b;const c=function(a,b=!0){return{target:{responseText:b?JSON.stringify(a):a}}};beforeEach(function(){b={nickname:'spinach',name:'Geoffrey Spinach',email:'spinach@example.com',business:!0,addresses:[{id:'address1',city:'New Orleans',postcode:'70130'}],vat:'1234',"business-name":'Spinachy business',"billing-addresses":[{id:'address2',city:'New Orleans',postcode:'70130'}],"payment-methods":[{address:{id:'address3',name:null,line1:null,line2:null,county:'Bunnyhug',city:'New Orleans',postcode:null,country:null,phones:[]},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',"card-holder":'Mr G Spinach',valid:!0,year:2017}],"allow-email":!0,valid:!0},a={nickname:'spinach',name:'Geoffrey Spinach',email:'spinach@example.com',business:!0,addresses:[{id:'address1',name:null,line1:null,line2:null,name:null,city:'New Orleans',county:null,postcode:'70130',country:null,phones:[]}],vat:'1234',businessName:'Spinachy business',billingAddresses:[{id:'address2',name:null,line1:null,line2:null,name:null,city:'New Orleans',county:null,postcode:'70130',country:null,phones:[]}],paymentMethods:[{address:{id:'address3',name:null,line1:null,line2:null,state:'Bunnyhug',city:'New Orleans',postcode:null,country:null},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',cardHolder:'Mr G Spinach',valid:!0,year:2017}],allowEmail:!0,valid:!0}}),it('exists',function(){const a=new window.jujulib.payment('http://1.2.3.4/',{});assert.strictEqual(a instanceof window.jujulib.payment,!0),assert.strictEqual(a.url,`http://1.2.3.4/${window.jujulib.paymentAPIVersion}`)}),it('can get a user',function(d){const e=new window.jujulib.payment('http://1.2.3.4/',{get:function(a,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach');const f=c(b);e(null,f)}});e.getUser('spinach',function(b,c){assert.strictEqual(b,null),assert.deepEqual(c,a),d()})}),it('can return correctly when getting a non-existent user',function(a){const b=new window.jujulib.payment('http://1.2.3.4/',{get:function(a,b,d){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach');const e=c();d(null,e)}});b.getUser('spinach',function(b,c){assert.strictEqual(b,null),assert.deepEqual(c,null),a()})}),it('can handle missing fields when getting a user',function(a){const b=new window.jujulib.payment('http://1.2.3.4/',{get:function(a,b,d){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach');const e=c({"billing-addresses":[{id:'address2',city:'New Orleans'}],"payment-methods":[{address:{id:'address3',city:'New Orleans'},id:'paymentmethod1'}]});d(null,e)}});b.getUser('spinach',function(b,c){assert.strictEqual(b,null),assert.deepEqual(c,{nickname:null,name:null,email:null,business:!1,addresses:[],vat:null,businessName:null,billingAddresses:[{id:'address2',name:null,line1:null,line2:null,name:null,city:'New Orleans',county:null,postcode:null,country:null,phones:[]}],paymentMethods:[{address:{id:'address3',name:null,line1:null,line2:null,state:null,city:'New Orleans',postcode:null,country:null},id:'paymentmethod1',brand:null,last4:null,month:null,name:null,cardHolder:null,valid:!1,year:null}],allowEmail:!1,valid:!1}),a()})}),it('handles errors when getting a user',function(a){const b=new window.jujulib.payment('http://1.2.3.4/',{get:function(a,b,d){const e=c({Error:'Uh oh!'});d(null,e)}});b.getUser('spinach',function(b,c){assert.equal(b,'Uh oh!'),assert.strictEqual(c,null),a()})}),it('can create a user',function(){const a={post:sinon.stub()},b=new window.jujulib.payment('http://1.2.3.4/',a);b.createUser({nickname:'spinach',name:'Geoffrey Spinach',email:'spinach@example.com',addresses:[{city:'New Orleans',postcode:'70130'}],vat:'1234',business:!0,businessName:'Spinachy business',billingAddresses:[{city:'New Orleans',postcode:'70130',country:'US'}],allowEmail:!0,token:'54321'},sinon.stub()),assert.deepEqual(JSON.parse(a.post.args[0][2]),{nickname:'spinach',name:'Geoffrey Spinach',email:'spinach@example.com',addresses:[{name:null,line1:null,line2:null,city:'New Orleans',county:null,postcode:'70130',"country-code":null,phones:[]}],vat:'1234',business:!0,"business-name":'Spinachy business',"billing-addresses":[{name:null,line1:null,line2:null,city:'New Orleans',county:null,postcode:'70130',"country-code":'US',phones:[]}],"allow-email":!0,token:'54321',"payment-method-name":null})}),it('can return the user when after creating a user',function(){const d=new window.jujulib.payment('http://1.2.3.4/',{post:function(a,d,e,f){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u');const g=c(b);f(null,g)}});d.createUser({name:'Geoffrey Spinach',email:'spinach@example.com',addresses:[{id:'address1',city:'New Orleans',postcode:'70130'}],vat:'1234',business:!0,businessName:'Spinachy business',billingAddresses:[{id:'address2',city:'New Orleans',postcode:'70130'}],allowEmail:!0,token:'54321'},function(b,c){assert.strictEqual(b,null),assert.deepEqual(c,a)})}),it('handles errors when creating a user',function(a){const b=new window.jujulib.payment('http://1.2.3.4/',{post:function(a,b,d,e){const f=c({Error:'Uh oh!'});e(null,f)}});b.createUser({},function(b,c){assert.equal(b,'Uh oh!'),assert.strictEqual(c,null),a()})}),it('can get a list of countries',function(a){const b=[{name:'Australia',code:'AU'}],d=new window.jujulib.payment('http://1.2.3.4/',{get:(a,d,e)=>{assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/country');const f=c({countries:b});e(null,f)}});d.getCountries((c,d)=>{assert.strictEqual(c,null),assert.deepEqual(d,b),a()})}),it('handles errors when getting the country list',function(a){const b=new window.jujulib.payment('http://1.2.3.4/',{get:(a,b,d)=>{const e=c({Error:'Uh oh!'});d(null,e)}});b.getCountries((b,c)=>{assert.equal(b,'Uh oh!'),assert.strictEqual(c,null),a()})}),describe('getPaymentMethods',()=>{it('can get payment methods for a user',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{get:function(a,b,d){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/payment-methods');const e=c({"payment-methods":[{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',"card-holder":'Mr G Spinach',valid:!0,year:2017}]});d(null,e)}});b.getPaymentMethods('spinach',function(b,c){assert.strictEqual(b,null),assert.deepEqual(c,[{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:null,state:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',cardHolder:'Mr G Spinach',valid:!0,year:2017}]),a()})}),it('handles errors when getting a user',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{get:function(a,b,d){const e=c({Message:'Uh oh!'});d(null,e)}});b.getPaymentMethods('spinach',function(b,c){assert.equal(b,'Uh oh!'),assert.strictEqual(c,null),a()})})}),describe('createPaymentMethod',()=>{it('can create a payment method',()=>{const a={post:sinon.stub()},b=new window.jujulib.payment('http://1.2.3.4/',a);b.createPaymentMethod('spinach','token123','Business',sinon.stub()),assert.equal(a.post.callCount,1),assert.deepEqual(a.post.args[0][2],JSON.stringify({"payment-method-name":'Business',token:'token123'}))}),it('can return the payment method when it has been created',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{post:function(a,b,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/payment-methods');const f=c({address:{id:'address1',name:'Home',line1:'1 Maple St',line2:'Loonie Lane',county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',"card-holder":'Mr G Spinach',valid:!0,year:2017});e(null,f)}});b.createPaymentMethod('spinach','token123',null,(b,c)=>{assert.strictEqual(b,null),assert.deepEqual(c,{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:'Loonie Lane',state:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',cardHolder:'Mr G Spinach',valid:!0,year:2017}),a()})}),it('handles errors when creating a payment method',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{post:function(a,b,d,e){const f=c({Message:'Uh oh!'});e(null,f)}});b.createPaymentMethod('spinach','token123',null,(b,c)=>{assert.equal(b,'Uh oh!'),assert.strictEqual(c,null),a()})})}),describe('updatePaymentMethod',()=>{it('can update a payment method',()=>{const a={put:sinon.stub()},b=new window.jujulib.payment('http://1.2.3.4/',a);b.updatePaymentMethod('spinach','paymentmethod1',{line1:'10 Maple St',line2:'',city:'Sasquatch',county:'Bunnyhug',postcode:'90210',country:'CA'},'12/17',sinon.stub()),assert.equal(a.put.callCount,1),assert.deepEqual(a.put.args[0][2],JSON.stringify({address:{name:null,line1:'10 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]},month:12,year:17}))}),it('can return when there are no errors',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/payment-methods/paymentmethod1/content');const f=c('success');e(null,f)}});b.updatePaymentMethod('spinach','paymentmethod1',{},'12/17',(b)=>{assert.strictEqual(b,null),a()})}),it('handles errors when updating a payment method',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){const f=c({Message:'Uh oh!'});e(null,f)}});b.updatePaymentMethod('spinach','paymentmethod1',{},'12/17',(b)=>{assert.equal(b,'Uh oh!'),a()})})}),describe('removePaymentMethod',()=>{it('can remove a payment method',()=>{const a={delete:sinon.stub()},b=new window.jujulib.payment('http://1.2.3.4/',a);b.removePaymentMethod('spinach','paymentmethod1',sinon.stub()),assert.equal(a.delete.callCount,1),assert.deepEqual(a.delete.args[0][2],JSON.stringify({"payment-method-name":'paymentmethod1'}))}),it('can return when there are no errors',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{delete:function(a,b,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/payment-methods/paymentmethod1');const f=c('success');e(null,f)}});b.removePaymentMethod('spinach','paymentmethod1',(b)=>{assert.strictEqual(b,null),a()})}),it('handles errors when removing a payment method',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{delete:function(a,b,d,e){const f=c({error:'Uh oh!'});e(null,f)}});b.removePaymentMethod('spinach','paymentmethod1',(b)=>{assert.equal(b,'Uh oh!'),a()})})}),describe('addAddress',()=>{let a;beforeEach(()=>{a={name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'CA'}}),it('can add an address',()=>{const b={put:sinon.stub()},c=new window.jujulib.payment('http://1.2.3.4/',b);c.addAddress('spinach',a,sinon.stub()),assert.equal(b.put.callCount,1),assert.deepEqual(b.put.args[0][2],JSON.stringify({name:'Home',line1:'1 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]}))}),it('can successfully create the address',(b)=>{const d=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/addresses');const f=c();e(null,f)}});d.addAddress('spinach',a,(a)=>{assert.strictEqual(a,null),b()})}),it('handles errors when adding an address',(b)=>{const d=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){const f=c({Message:'Uh oh!'});e(null,f)}});d.addAddress('spinach',a,(a)=>{assert.equal(a,'Uh oh!'),b()})})}),describe('addBillingAddress',()=>{let a;beforeEach(()=>{a={name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'CA'}}),it('can add a billing address',()=>{const b={put:sinon.stub()},c=new window.jujulib.payment('http://1.2.3.4/',b);c.addBillingAddress('spinach',a,sinon.stub()),assert.equal(b.put.callCount,1),assert.deepEqual(b.put.args[0][2],JSON.stringify({name:'Home',line1:'1 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]}))}),it('can successfully create the billing address',(b)=>{const d=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/billing-addresses');const f=c();e(null,f)}});d.addBillingAddress('spinach',a,(a)=>{assert.strictEqual(a,null),b()})}),it('handles errors when adding a billing address',(b)=>{const d=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){const f=c({Message:'Uh oh!'});e(null,f)}});d.addBillingAddress('spinach',a,(a)=>{assert.equal(a,'Uh oh!'),b()})})}),describe('removeAddress',()=>{it('can remove an address',()=>{const a={delete:sinon.stub()},b=new window.jujulib.payment('http://1.2.3.4/',a);b.removeAddress('spinach','address1',sinon.stub()),assert.equal(a.delete.callCount,1),assert.strictEqual(a.delete.args[0][2],null)}),it('can return when there are no errors',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{delete:function(a,b,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/addresses/address1');const f=c('success');e(null,f)}});b.removeAddress('spinach','address1',(b)=>{assert.strictEqual(b,null),a()})}),it('handles errors when removing an address',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{delete:function(a,b,d,e){const f=c({error:'Uh oh!'});e(null,f)}});b.removeAddress('spinach','address1',(b)=>{assert.equal(b,'Uh oh!'),a()})})}),describe('removeBillingAddress',()=>{it('can remove a biling address',()=>{const a={delete:sinon.stub()},b=new window.jujulib.payment('http://1.2.3.4/',a);b.removeBillingAddress('spinach','address1',sinon.stub()),assert.equal(a.delete.callCount,1),assert.strictEqual(a.delete.args[0][2],null)}),it('can return when there are no errors',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{delete:function(a,b,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/billing-addresses/address1');const f=c('success');e(null,f)}});b.removeBillingAddress('spinach','address1',(b)=>{assert.strictEqual(b,null),a()})}),it('handles errors when removing a billing address',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{delete:function(a,b,d,e){const f=c({error:'Uh oh!'});e(null,f)}});b.removeBillingAddress('spinach','address1',(b)=>{assert.equal(b,'Uh oh!'),a()})})}),describe('updateAddress',()=>{let a;beforeEach(()=>{a={name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'CA'}}),it('can update an address',()=>{const b={put:sinon.stub()},c=new window.jujulib.payment('http://1.2.3.4/',b);c.updateAddress('spinach','address1',a,sinon.stub()),assert.equal(b.put.callCount,1),assert.deepEqual(JSON.parse(b.put.args[0][2]),{id:'address1',name:'Home',line1:'1 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]})}),it('can successfully update the address',(b)=>{const d=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/addresses/address1');const f=c();e(null,f)}});d.updateAddress('spinach','address1',a,(a)=>{assert.strictEqual(a,null),b()})}),it('handles errors when updating an address',(b)=>{const d=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){const f=c({Message:'Uh oh!'});e(null,f)}});d.updateAddress('spinach','address1',a,(a)=>{assert.equal(a,'Uh oh!'),b()})})}),describe('updateBillingAddress',()=>{let a;beforeEach(()=>{a={name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'CA'}}),it('can update a billing address',()=>{const b={put:sinon.stub()},c=new window.jujulib.payment('http://1.2.3.4/',b);c.updateBillingAddress('spinach','address1',a,sinon.stub()),assert.equal(b.put.callCount,1),assert.deepEqual(JSON.parse(b.put.args[0][2]),{id:'address1',name:'Home',line1:'1 Maple St',line2:null,city:'Sasquatch',county:'Bunnyhug',postcode:'90210',"country-code":'CA',phones:[]})}),it('can successfully update the billing address',(b)=>{const d=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/u/spinach/billing-addresses/address1');const f=c();e(null,f)}});d.updateBillingAddress('spinach','address1',a,(a)=>{assert.strictEqual(a,null),b()})}),it('handles errors when updating a billing address',(b)=>{const d=new window.jujulib.payment('http://1.2.3.4/',{put:function(a,b,d,e){const f=c({error:'Uh oh!'});e(null,f)}});d.updateBillingAddress('spinach','address1',a,(a)=>{assert.equal(a,'Uh oh!'),b()})})}),describe('getCharges',()=>{it('can get a list of charges',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{get:function(a,b,d){assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/charges?nickname=spinach');const e=c({charges:[{id:'TEST-12344',"statement-id":'12344',price:1e4,vat:2e3,currency:'USD',nickname:'spinach',for:'2016-01-02T15:04:05Z',origin:'TEST',state:'done',"line-items":[{name:'this is line 1',details:'a bit more details for line 1',usage:'something',price:'48'}],"payment-received-at":'2017-04-28T07:49:39.925Z',"payment-method-used":{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:null,county:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',"card-holder":'Mr G Spinach',valid:!0,year:2017},"payment-retry-delay":10,"payment-retry-max":2,"payment-method-update-retry-delay":10,"payment-method-update-retry-max":100}]});d(null,e)}});b.getCharges('spinach',(b,c)=>{assert.strictEqual(b,null),assert.deepEqual(c,[{id:'TEST-12344',statementId:'12344',price:1e4,vat:2e3,currency:'USD',nickname:'spinach',for:'2016-01-02T15:04:05Z',origin:'TEST',state:'done',lineItems:[{name:'this is line 1',details:'a bit more details for line 1',usage:'something',price:'48'}],paymentReceivedAt:'2017-04-28T07:49:39.925Z',paymentMethodUsed:{address:{id:'address1',name:'Home',line1:'1 Maple St',line2:null,state:'Bunnyhug',city:'Sasquatch',postcode:'90210',country:'North of the Border'},id:'paymentmethod1',brand:'Brand',last4:'1234',month:3,name:'Main',cardHolder:'Mr G Spinach',valid:!0,year:2017},paymentRetryDelay:10,paymentRetryMax:2,paymentMethodUpdateRetryDelay:10,paymentMethodUpdateRetryMax:100}]),a()})}),it('handles errors when getting charges',(a)=>{const b=new window.jujulib.payment('http://1.2.3.4/',{get:function(a,b,d){const e=c({Message:'Uh oh!'});d(null,e)}});b.getCharges('spinach',(b,c)=>{assert.equal(b,'Uh oh!'),assert.strictEqual(c,null),a()})})}),describe('getReceipt',()=>{it('can get a receipt',function(a){const b=new window.jujulib.payment('http://1.2.3.4/',{get:(a,b,d)=>{assert.equal(a,'http://1.2.3.4/'+window.jujulib.paymentAPIVersion+'/receipts/charge123');const e=c('<html>...</html>',!1);d(null,e)}});b.getReceipt('charge123',(b,c)=>{assert.strictEqual(b,null),assert.equal(c,'<html>...</html>'),a()})}),it('handles errors when getting a receipt',function(a){const b=new window.jujulib.payment('http://1.2.3.4/',{get:(a,b,d)=>{const e=c({error:'Uh oh!'});d(null,e)}});b.getReceipt('charge123',(b,c)=>{assert.equal(b,'Uh oh!'),assert.strictEqual(c,null),a()})})})});